package sun.reflect;

import java.lang.reflect.Modifier;
import java.lang.reflect.Field;

class UnsafeFieldAccessorFactory
{
    UnsafeFieldAccessorFactory() {
    }
    
    static FieldAccessor newFieldAccessor(Field field, boolean b) {
        Class<Object> type = field.getType();
        int static1 = Modifier.isStatic(field.getModifiers());
        int final1 = Modifier.isFinal(field.getModifiers());
        int volatile1 = Modifier.isVolatile(field.getModifiers());
        int n = final1 || volatile1;
        int n2 = final1 && (static1 || !b);
        if (!(static1 == 0)) {
            UnsafeFieldAccessorImpl.unsafe.ensureClassInitialized(field.getDeclaringClass());
            if (n == 0) {
                if (type == Boolean.TYPE) {
                    return new UnsafeStaticBooleanFieldAccessorImpl(field);
                }
                if (type == Byte.TYPE) {
                    return new UnsafeStaticByteFieldAccessorImpl(field);
                }
                if (type == Short.TYPE) {
                    return new UnsafeStaticShortFieldAccessorImpl(field);
                }
                if (type == Character.TYPE) {
                    return new UnsafeStaticCharacterFieldAccessorImpl(field);
                }
                if (type == Integer.TYPE) {
                    return new UnsafeStaticIntegerFieldAccessorImpl(field);
                }
                if (type == Long.TYPE) {
                    return new UnsafeStaticLongFieldAccessorImpl(field);
                }
                if (type == Float.TYPE) {
                    return new UnsafeStaticFloatFieldAccessorImpl(field);
                }
                if (type == Double.TYPE) {
                    return new UnsafeStaticDoubleFieldAccessorImpl(field);
                }
                return new UnsafeStaticObjectFieldAccessorImpl(field);
            }
            else {
                if (type == Boolean.TYPE) {
                    return new UnsafeQualifiedStaticBooleanFieldAccessorImpl(field, (boolean)n2);
                }
                if (type == Byte.TYPE) {
                    return new UnsafeQualifiedStaticByteFieldAccessorImpl(field, (boolean)n2);
                }
                if (type == Short.TYPE) {
                    return new UnsafeQualifiedStaticShortFieldAccessorImpl(field, (boolean)n2);
                }
                if (type == Character.TYPE) {
                    return new UnsafeQualifiedStaticCharacterFieldAccessorImpl(field, (boolean)n2);
                }
                if (type == Integer.TYPE) {
                    return new UnsafeQualifiedStaticIntegerFieldAccessorImpl(field, (boolean)n2);
                }
                if (type == Long.TYPE) {
                    return new UnsafeQualifiedStaticLongFieldAccessorImpl(field, (boolean)n2);
                }
                if (type == Float.TYPE) {
                    return new UnsafeQualifiedStaticFloatFieldAccessorImpl(field, (boolean)n2);
                }
                if (type == Double.TYPE) {
                    return new UnsafeQualifiedStaticDoubleFieldAccessorImpl(field, (boolean)n2);
                }
                return new UnsafeQualifiedStaticObjectFieldAccessorImpl(field, (boolean)n2);
            }
        }
        else if (n == 0) {
            if (type == Boolean.TYPE) {
                return new UnsafeBooleanFieldAccessorImpl(field);
            }
            if (type == Byte.TYPE) {
                return new UnsafeByteFieldAccessorImpl(field);
            }
            if (type == Short.TYPE) {
                return new UnsafeShortFieldAccessorImpl(field);
            }
            if (type == Character.TYPE) {
                return new UnsafeCharacterFieldAccessorImpl(field);
            }
            if (type == Integer.TYPE) {
                return new UnsafeIntegerFieldAccessorImpl(field);
            }
            if (type == Long.TYPE) {
                return new UnsafeLongFieldAccessorImpl(field);
            }
            if (type == Float.TYPE) {
                return new UnsafeFloatFieldAccessorImpl(field);
            }
            if (type == Double.TYPE) {
                return new UnsafeDoubleFieldAccessorImpl(field);
            }
            return new UnsafeObjectFieldAccessorImpl(field);
        }
        else {
            if (type == Boolean.TYPE) {
                return new UnsafeQualifiedBooleanFieldAccessorImpl(field, (boolean)n2);
            }
            if (type == Byte.TYPE) {
                return new UnsafeQualifiedByteFieldAccessorImpl(field, (boolean)n2);
            }
            if (type == Short.TYPE) {
                return new UnsafeQualifiedShortFieldAccessorImpl(field, (boolean)n2);
            }
            if (type == Character.TYPE) {
                return new UnsafeQualifiedCharacterFieldAccessorImpl(field, (boolean)n2);
            }
            if (type == Integer.TYPE) {
                return new UnsafeQualifiedIntegerFieldAccessorImpl(field, (boolean)n2);
            }
            if (type == Long.TYPE) {
                return new UnsafeQualifiedLongFieldAccessorImpl(field, (boolean)n2);
            }
            if (type == Float.TYPE) {
                return new UnsafeQualifiedFloatFieldAccessorImpl(field, (boolean)n2);
            }
            if (type == Double.TYPE) {
                return new UnsafeQualifiedDoubleFieldAccessorImpl(field, (boolean)n2);
            }
            return new UnsafeQualifiedObjectFieldAccessorImpl(field, (boolean)n2);
        }
    }
}
